/*
!=======================================================================
!
!  PROGRAM  PHASE-Viewer  (PHASE-Viewer 2014.01 ver.3.3.0)
!
!  Created on 2005/11/07, 17:46
!  AUTHOR(S): KOGA, Junichiro
!  File : OutputData.java
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!
!
!   Since 2002, this program set had been intensively developed as a part of the following 
!  national projects supported by the Ministry of Education, Culture, Sports, Science and
!  Technology (MEXT) of Japan; "Frontier Simulation Software for Industrial Science
!  (FSIS)" from 2002 to 2005, "Revolutionary Simulation Software (RSS21)" from 2006 to
!  2008. "Research and Development of Innovative Simulation Software (RISS)" from 2008
!  to 2013. These projects is lead by the Center for Research on Innovative Simulation 
!  Software (CISS), the Institute of Industrial Science (IIS), the University of Tokyo.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium. 
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!=======================================================================
 */

package ciss.phase_viewer.outputinterface;

import org.apache.log4j.Logger;

/**
 * 出力データ情報をカプセル化するクラス.
 * 
 * @author
 */
public class OutputData {
    private Logger logger = Logger.getLogger(OutputData.class.getName());

    private String name = "";
    private String description = "";
    private String[] identifier;
    private String[][] data2d;
    private int numRows;
    private int numCols;
    private String header = "";

    private String fileName = "";

    /**
     * 特に初期化などは行わないコンストラクター. これを利用する場合, setterでしかるべき値をセットすること.
     */
    public OutputData() {
    }

    /**
     * 必要と思われる情報を一通り指定するコンストラクター.
     * 
     * @param name
     *            このデータの名前
     * @param description
     *            このデータの説明(タブのツールチップなどに利用される)
     * @param identifier
     *            このデータの識別子; データの列の数と同数にすることが望ましい.
     * @param data2d
     *            データそのもの. 二次元の文字列配列で, 第一要素が行, 第二要素が列に対応する.
     * @param header
     *            データのヘッダー. なければないでよい.
     */
    public OutputData(String name, String description, String[] identifier,
            String[][] data2d, String header) {
        this.name = name;
        this.description = description;
        setIdentifier(identifier);
        setData2D(data2d);
        this.header = header;
    }

    /**
     * このデータの名前を返す. タブのテキストなんかに使う予定.
     * 
     * @return このデータの名前.
     */
    public String getName() {
        return name;
    }

    /**
     * このデータの名前をセットする. タブのテキストなんかに使う予定.
     * 
     * @param このデータの名前
     *            .
     */
    public void setName(String name) {
        this.name = name;
    }

    /**
     * このデータに関する説明を返す. タブのツールチップなんかに利用する予定.
     * 
     * @return データの簡単な説明.
     */
    public String getDescription() {
        return description;
    }

    /**
     * このデータに関する説明をセットする. タブのツールチップなんかに利用する予定.
     * 
     * @param データの簡単な説明
     *            . 改行などは多分無意味なので入れないこと.
     */
    public void setDescription(String description) {
        this.description = description;
    }

    /**
     * データの識別子を, 文字列配列で取得する. テーブルカラムなどに利用する.
     * 
     * @param データの識別子配列
     *            .
     */
    public String[] getIdentifier() {
        return identifier;
    }

    /**
     * データの識別子をセットする. この配列の大きさからカラム長も定義するので consistentになるような配列をセットせよ.
     * 
     * @param データの識別子配列
     *            .
     */
    public void setIdentifier(String[] identifier) {
        this.identifier = identifier;
        if (identifier != null && identifier.length != 0) {
            numCols = identifier.length;
        }
    }

    /**
     * 「二次元のデータ」を取得する.
     * 
     * @return 二次元データ
     */
    public String[][] getData2D() {
        return data2d;
    }

    /**
     * 「二次元データ」をセットする. この情報から行の数を設定するのでちゃんとした データを入れること.
     * 
     * @param 二次元データ
     */
    public void setData2D(String[][] data2d) {
        this.data2d = data2d;
        if (data2d != null && data2d.length != 0) {
            numRows = data2d.length;
        }
    }

    /**
     * データの行の数を返す.
     * 
     * @return 行の数.
     */
    public int getNumRows() {
        return numRows;
    }

    /**
     * データの列の数を返す.
     * 
     * @return データの列の数.
     */
    public int getNumCols() {
        return numCols;
    }

    /**
     * このデータのヘッダーを取得.
     * 
     * @return データのヘッダー.
     */
    public String getHeader() {
        return header;
    }

    /**
     * このデータのヘッダーを設定する.
     * 
     * @param headerこのデータのヘッダー
     *            .
     */
    public void setHeader(String header) {
        this.header = header;
    }

    /**
     * このデータの, 読込先のファイル名をセット.
     * 
     * @param fileName
     *            ファイル名
     */
    public void setFileName(String fileName) {
        this.fileName = fileName;
    }

    /**
     * このデータの, 読込先のファイル名をゲット.
     * 
     * @return ファイル名
     */
    public String getFileName() {
        return fileName;
    }

    public String toString() {
        String ret = "";
        for (int i = 0; i < data2d.length; i++) {
            for (int j = 0; j < data2d[i].length; j++) {
                ret += data2d[i][j] + " ";
            }
            ret += System.getProperty("line.separator");
        }
        return ret;
    }
}
